//***************** (c) 2009 BTC Korporacja ***********************************
//                     http://www.kamami.pl
// PROJECT  : STM32 Tech Days 2009 - Lab2 (GPIO) 
// BOARD    : STM32Butterfly (with STM32F107VB)
// COMPILER : Keil MDK 4.01
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple GPIO demonstration.
//******************************************************************************


// Includes ------------------------------------------------------------------
#include "stm32f10x.h"

#define JOY_L	(1 << 12)
#define JOY_R	(1 << 11)
#define JOY_U	(1 << 9)
#define JOY_D	(1 << 10)
#define JOY_C	(1 << 8)

// Private function prototypes -----------------------------------------------
void GPIO_Configuration(void);

int main(void)
{
  // GPIO Configuration
  GPIO_Configuration();

  // Turn off LEDs
  GPIO_SetBits(GPIOE, GPIO_Pin_14 | GPIO_Pin_15); 

  while (1)
  {
    if(GPIO_ReadInputDataBit(GPIOE, JOY_R) == 0)          
	  GPIO_ResetBits(GPIOE, GPIO_Pin_15);
    else
	  GPIO_SetBits(GPIOE, GPIO_Pin_15);

    if(GPIO_ReadInputDataBit(GPIOE, JOY_L) == 0)
      GPIO_ResetBits(GPIOE, GPIO_Pin_14);
    else
	  GPIO_SetBits(GPIOE, GPIO_Pin_14);
  }
}


void GPIO_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  
  /* Configure all unused GPIO port pins in Analog Input mode (floating input
     trigger OFF), this will reduce the power consumption and increase the device
     immunity against EMI/EMC *************************************************/

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD |
                         RCC_APB2Periph_GPIOE, ENABLE);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  GPIO_Init(GPIOC, &GPIO_InitStructure);
  GPIO_Init(GPIOD, &GPIO_InitStructure);
  GPIO_Init(GPIOE, &GPIO_InitStructure);

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB |
                         RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD |
                         RCC_APB2Periph_GPIOE, DISABLE);  
 	

  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOE | RCC_APB2Periph_AFIO, ENABLE);	

  // Configuration of LED pins
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_14 | GPIO_Pin_15;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
  GPIO_Init(GPIOE, &GPIO_InitStructure);

  // Configuration of joystick pins
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
  GPIO_Init(GPIOE, &GPIO_InitStructure);
}
